    001/* ===========================================================
    002 * JFreeChart : a free chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jfreechart/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    025 * Other names may be trademarks of their respective owners.]
    026 *
    027 * -------------
    028 * TickType.java
    029 * -------------
    030 * (C) Copyright 2007, 2008, by Object Refinery Limited.
    031 *
    032 * Original Author:  David Gilbert (for Object Refinery Limited);
    033 * Contributor(s):   -;
    034 *
    035 * Changes:
    036 * --------
    037 * 02-Aug-2007 : Version 1 (DG);
    038 *
    039 */
    040
    041package org.jfree.chart.axis;
    042
    043import java.io.ObjectStreamException;
    044import java.io.Serializable;
    045
    046/**
    047 * Used to indicate the tick type (MAJOR or MINOR).
    048 *
    049 * @since 1.0.7
    050 */
    051public final class TickType implements Serializable {
    052
    053    /** Major tick. */
    054    public static final TickType MAJOR = new TickType("MAJOR");
    055
    056    /** Minor tick. */
    057    public static final TickType MINOR = new TickType("MINOR");
    058
    059    /** The name. */
    060    private String name;
    061
    062    /**
    063     * Private constructor.
    064     *
    065     * @param name  the name.
    066     */
    067    private TickType(String name) {
    068        this.name = name;
    069    }
    070
    071    /**
    072     * Returns a string representing the object.
    073     *
    074     * @return The string.
    075     */
    076    public String toString() {
    077        return this.name;
    078    }
    079
    080    /**
    081     * Returns <code>true</code> if this object is equal to the specified
    082     * object, and <code>false</code> otherwise.
    083     *
    084     * @param obj  the other object.
    085     *
    086     * @return A boolean.
    087     */
    088    public boolean equals(Object obj) {
    089        if (this == obj) {
    090            return true;
    091        }
    092        if (!(obj instanceof TickType)) {
    093            return false;
    094        }
    095
    096        TickType that = (TickType) obj;
    097        if (!this.name.equals(that.name)) {
    098            return false;
    099        }
    100        return true;
    101    }
    102
    103    /**
    104     * Ensures that serialization returns the unique instances.
    105     *
    106     * @return The object.
    107     *
    108     * @throws ObjectStreamException if there is a problem.
    109     */
    110    private Object readResolve() throws ObjectStreamException {
    111        Object result = null;
    112        if (this.equals(TickType.MAJOR)) {
    113            result = TickType.MAJOR;
    114        }
    115        else if (this.equals(TickType.MINOR)) {
    116            result = TickType.MINOR;
    117        }
    118        return result;
    119    }
    120
    121}